%{?mingw_package_header}

Name:           mingw-SDL
Version:        1.2.15
Release:        %mkrel 15
Summary:        MinGW Windows port of SDL cross-platform multimedia library

License:        LGPLv2+
Group:          Development/Other
URL:            https://www.libsdl.org/
Source0:        https://www.libsdl.org/release/SDL-%{version}.tar.gz

# Synced with Fedora
Patch100:	SDL-1.2.15-CVE-2019-7577-Fix-a-buffer-overread-in-MS_ADPCM_deco.patch
# Fix CVE-2019-7575 (a buffer overwrite in MS_ADPCM_decode), bug #1676744,
# upstream bug #4493, proposed to upstream
Patch101:	SDL-1.2.15-CVE-2019-7575-Fix-a-buffer-overwrite-in-MS_ADPCM_dec.patch
# Fix CVE-2019-7574 (a buffer overread in IMA_ADPCM_decode), bug #1676750,
# upstream bug #4496, proposed to upstream
Patch102:	SDL-1.2.15-CVE-2019-7574-Fix-a-buffer-overread-in-IMA_ADPCM_dec.patch
# Fix CVE-2019-7572 (a buffer overread in IMA_ADPCM_nibble), bug #1676754,
# upstream bug #4495, proposed to upstream
Patch103:	SDL-1.2.15-CVE-2019-7572-Fix-a-buffer-overread-in-IMA_ADPCM_nib.patch
# Fix CVE-2019-7572 (a buffer overwrite in IMA_ADPCM_nibble), bug #1676754,
# upstream bug #4495, proposed to upstream
Patch104:	SDL-1.2.15-CVE-2019-7572-Fix-a-buffer-overwrite-in-IMA_ADPCM_de.patch
# Fix CVE-2019-7573, CVE-2019-7576 (buffer overreads in InitMS_ADPCM),
# bugs #1676752, #1676756, upstream bugs #4491, #4490, proposed to upstream
Patch105:	SDL-1.2.15-CVE-2019-7573-CVE-2019-7576-Fix-buffer-overreads-in-.patch
# Fix CVE-2019-7578, (a buffer overread in InitIMA_ADPCM), bug #1676782,
# upstream bug #4491, proposed to upstream
Patch106:	SDL-1.2.15-CVE-2019-7578-Fix-a-buffer-overread-in-InitIMA_ADPCM.patch
# Fix CVE-2019-7638, CVE-2019-7636 (buffer overflows when processing BMP
# images with too high number of colors), bugs #1677144, #1677157,
# upstream bugs #4500, #4499, in upstream after 1.2.15
Patch107:	SDL-1.2.15-CVE-2019-7638-CVE-2019-7636-Refuse-loading-BMP-image.patch
# Fix CVE-2019-7637 (an integer overflow in SDL_CalculatePitch), bug #1677152,
# upstream bug #4497, in upstream after 1.2.15
Patch108:	SDL-1.2.15-CVE-2019-7637-Fix-in-integer-overflow-in-SDL_Calcula.patch
# Fix CVE-2019-7635 (a buffer overread when blitting a BMP image with pixel
# colors out the palette), bug #1677159, upstream bug #4498,
# proposed to upstream
Patch109:	SDL-1.2.15-CVE-2019-7635-Reject-BMP-images-with-pixel-colors-ou.patch
# Reject 2, 3, 5, 6, 7-bpp BMP images (related to CVE-2019-7635),
# bug #1677159, upstream bug #4498, in upstream after 1.2.15
Patch110:	SDL-1.2.15-Reject-2-3-5-6-7-bpp-BMP-images.patch
# Fix CVE-2019-7577 (Fix a buffer overread in MS_ADPCM_nibble and
# MS_ADPCM_decode on an invalid predictor), bug #1676510, upstream bug #4492,
# proposed to upstream
Patch111:	SDL-1.2.15-CVE-2019-7577-Fix-a-buffer-overread-in-MS_ADPCM_nibb.patch

BuildArch:      noarch

BuildRequires:  mingw32-filesystem >= 95
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw32-win-iconv

BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils
BuildRequires:  mingw64-win-iconv

# Not required at the moment, but SDL does contain plenty of C++ code,
# I just haven't worked out how to enable it.
#BuildRequires:  mingw32-gcc-c++

%ifarch %{ix86}
BuildRequires: nasm
%endif


%description
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.


# Win32
%package -n mingw32-SDL
Summary:        MinGW Windows port of SDL cross-platform multimedia library
Requires:       pkgconfig
# kraxel pointed out that the headers need <iconv.h>, hence:
Requires:       mingw32-win-iconv

%description -n mingw32-SDL
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

# Win32
%package -n mingw64-SDL
Summary:        MinGW Windows port of SDL cross-platform multimedia library
Requires:       pkgconfig
# kraxel pointed out that the headers need <iconv.h>, hence:
Requires:       mingw64-win-iconv

%description -n mingw64-SDL
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.


%?mingw_debug_package


%prep
%setup -q -n SDL-%{version}

%patch -P 100 -p1
%patch -P 101 -p1
%patch -P 102 -p1
%patch -P 103 -p1
%patch -P 104 -p1
%patch -P 105 -p1
%patch -P 106 -p1
%patch -P 107 -p1
%patch -P 108 -p1
%patch -P 109 -p1
%patch -P 110 -p1
%patch -P 111 -p1


%build
%mingw_configure
%mingw_make %{?_smp_mflags}


%install
%mingw_make DESTDIR=$RPM_BUILD_ROOT install

# Remove static libraries but DON'T remove *.dll.a files.
rm $RPM_BUILD_ROOT%{mingw32_libdir}/libSDL.a
rm $RPM_BUILD_ROOT%{mingw64_libdir}/libSDL.a

# Actually libSDLmain.a seems to be required.  It just contains
# a single object file called SDL_win32_main.o.
#rm $RPM_BUILD_ROOT%{mingw32_libdir}/libSDLmain.a
#rm $RPM_BUILD_ROOT%{mingw64_libdir}/libSDLmain.a

# Delete man pages since they duplicate what is already available
# in base Fedora package.
rm $RPM_BUILD_ROOT%{mingw32_mandir}/man3/*.3*
rm $RPM_BUILD_ROOT%{mingw64_mandir}/man3/*.3*

# Drop all .la files
find $RPM_BUILD_ROOT -name "*.la" -delete


# Win32
%files -n mingw32-SDL
%doc COPYING
%{mingw32_bindir}/SDL.dll
%{mingw32_bindir}/sdl-config
%{mingw32_libdir}/libSDL.dll.a
%{mingw32_libdir}/libSDLmain.a
%{mingw32_libdir}/pkgconfig/sdl.pc
%{mingw32_datadir}/aclocal/sdl.m4
%{mingw32_includedir}/SDL

# Win64
%files -n mingw64-SDL
%doc COPYING
%{mingw64_bindir}/SDL.dll
%{mingw64_bindir}/sdl-config
%{mingw64_libdir}/libSDL.dll.a
%{mingw64_libdir}/libSDLmain.a
%{mingw64_libdir}/pkgconfig/sdl.pc
%{mingw64_datadir}/aclocal/sdl.m4
%{mingw64_includedir}/SDL




%changelog
* Sun Dec 22 2024 pterjan <pterjan> 1.2.15-15.mga10
+ Revision: 2127832
- Rebuild for patchN deprecation

* Thu Mar 24 2022 umeabot <umeabot> 1.2.15-14.mga9
+ Revision: 1825440
- Mageia 9 Mass Rebuild

* Sat Sep 26 2020 tv <tv> 1.2.15-13.mga8
+ Revision: 1630224
- rebuild for new mingw stack

* Fri Sep 25 2020 akien <akien> 1.2.15-12.mga8
+ Revision: 1630103
- Rebuild for new mingw-gcc

* Sat Feb 15 2020 umeabot <umeabot> 1.2.15-11.mga8
+ Revision: 1524265
- Mageia 8 Mass Rebuild

* Fri Mar 29 2019 akien <akien> 1.2.15-10.mga7
+ Revision: 1381071
- Sync security patches with Fedora: Tue Mar 12 2019 Petr Pisar <ppisar@redhat.com> - 1.2.15-38
  o Fix CVE-2019-7577 completely (a buffer overread in MS_ADPCM_nibble and
    MS_ADPCM_decode on an invalid predictor) (bug #1676510)
  o Fix CVE-2019-7577 (a buffer overread in MS_ADPCM_decode) (bug #1676510)
  o Fix CVE-2019-7575 (a buffer overwrite in MS_ADPCM_decode) (bug #1676744)
  o Fix CVE-2019-7574 (a buffer overread in IMA_ADPCM_decode) (bug #1676750)
  o Fix CVE-2019-7572 (a buffer overread in IMA_ADPCM_nibble) (bug #1676754)
  o Fix CVE-2019-7572 (a buffer overwrite in IMA_ADPCM_nibble) (bug #1676754)
  o Fix CVE-2019-7573, CVE-2019-7576 (buffer overreads in InitMS_ADPCM)
    (bugs #1676752, #1676756)
  o Fix CVE-2019-7578 (a buffer overread in InitIMA_ADPCM) (bug #1676782)
  o Fix CVE-2019-7638, CVE-2019-7636 (buffer overflows when processing BMP
    images with too high number of colors) (bugs #1677144, #1677157)
  o Fix CVE-2019-7637 (an integer overflow in SDL_CalculatePitch) (bug #1677152)
  o Fix CVE-2019-7635 (a buffer overread when blitting a BMP image with pixel
    colors out the palette) (bug #1677159)
  o Reject 2, 3, 5, 6, 7-bpp BMP images (bug #1677159)

* Wed Sep 19 2018 umeabot <umeabot> 1.2.15-9.mga7
+ Revision: 1264439
- Mageia 7 Mass Rebuild

* Mon Feb 08 2016 umeabot <umeabot> 1.2.15-8.mga6
+ Revision: 946390
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 1.2.15-7.mga5
+ Revision: 739992
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.2.15-6.mga5
+ Revision: 682401
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 1.2.15-5.mga4
+ Revision: 536153
- Mageia 4 Mass Rebuild

* Sun Sep 22 2013 neoclust <neoclust> 1.2.15-4.mga4
+ Revision: 483376
- imported package mingw-SDL


* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.15-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.15-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.15-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sun Jun 02 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 1.2.15-1
- Update to 1.2.15
- Dropped upstreamed patches
- Dropped all configure arguments which aren't relevant for the win32/win64 targets
- Add BR: nasm

* Sat Apr 14 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 1.2.13-15
- Added win64 support
- Automatically generate debuginfo package
- Use parallel make
- Dropped unneeded BR: mingw32-dlfcn

* Fri Mar 09 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 1.2.13-14
- Dropped .la files

* Wed Mar 07 2012 Kalev Lember <kalevlember@gmail.com> - 1.2.13-13
- Renamed the source package to mingw-SDL (#801028)
- Modernize the spec file
- Use mingw macros without leading underscore

* Mon Feb 27 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 1.2.13-12
- Rebuild against the mingw-w64 toolchain
- Build without directx support as it isn't ready yet for the mingw-w64 toolchain

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.13-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Jul 06 2011 Kalev Lember <kalevlember@gmail.com> - 1.2.13-10
- Rebuilt against win-iconv

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.13-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.13-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Apr 29 2009 Richard W.M. Jones <rjones@redhat.com> - 1.2.13-7
- Add runtime Requires mingw32-iconv (kraxel).

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.13-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Feb 20 2009 Richard W.M. Jones <rjones@redhat.com> - 1.2.13-5
- Rebuild for mingw32-gcc 4.4

* Tue Jan 13 2009 Richard W.M. Jones <rjones@redhat.com> - 1.2.13-4
- Verify we are still up to date with Fedora release.
- Include COPYING in documentation.
- Build with dlfcn.
- List all BRs.
- No need to package the man pages, don't duplicate what's in the
  base Fedora package already.
- Requires pkgconfig.

* Fri Oct 24 2008 Richard W.M. Jones <rjones@redhat.com> - 1.2.13-2
- Initial RPM release.
